// This program is designed for ADUC_MT7020 board
// It shows how to work with LCD and DAC (only DAC, without ADC)
// Program manage LCD light by DAC

#include <ioaduc7020.h>
#include "system.h"
#include "adc_dac.h"
#include "lcd.h"

#define BUT1  GP0DAT & 0x00000010
#define	BUT2  GP0DAT & 0x00000020

void DelaymS (unsigned long a) { while (--a!=0); }

int main()
{
  // Init frequency
  InitFreq();
  // Init ADC
  InitADC();
  // Init LCD
  LCDInit();
  LCDSendCommand(DISP_ON);      //LCD on
  LCDSendCommand(CLR_DISP);     //LCD clear
  LCDSendCommand(DD_RAM_ADDR);  //LCD set first row

  // Write to LCD
  LCDSendTxt(" www.olimex.com ");
  DAC3DAT = 0x0fff0000;

  // loop forever
  while(1) {

    //check that Button 1 is pressed - increace LCD light
    if(!(BUT1)) {
      // check out of range
      if(DAC3DAT<0x0ff00000) Set_DAC(3, DAC3DAT+0x000f0000); // increase DAC value
      DelaymS(20000);
    }

    //check that Button 2 is pressed - decrease LCD light
    if(!(BUT2)) {
      // check out of range
      if(DAC3DAT>0x000f0000) Set_DAC(3, DAC3DAT-0x000f0000); // decrease DAC value
      DelaymS(20000);
    }
  }

}
